routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'UsersController@index')->name('home')->middleware('auth');

Route::resource('posts', 'PostsController')->middleware('auth');
Route::resource('posts.comments', 'CommentsController')->middleware('auth');
Route::resource('users', 'UsersController')->only('index')->middleware('auth');
Route::get('follow/{user}', 'UsersController@follow')->name('follow')->middleware('auth');
Route::resource('posts.likes', 'LikesController')->only('store')->middleware('auth');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    protected $fillable = ['user_id', 'image', 'description'];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function user() {
        return $this->belongsTo(User::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function comments() {
        return $this->hasMany(Comment::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function likes()
    {
        return $this->hasMany(Like::class);
    }
}

app/Http/Controllers/PostsController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PostRequest;
use App\Post;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PostsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        $posts = Post::all();
        $user = Auth::user();
        $users = $user->subscriptions()->get();
        return view('posts.index', compact('posts', 'users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view('posts.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param PostRequest $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(PostRequest $request)
    {
        $validated = $request->validated();
        Auth::user();
        $post = new Post();

        $data = $request->all();
        $file = $request->file('image');
        if (!is_null($file)) {
            $path = $file->store('images', 'public');
            $data['image'] = $path;
        }

        $post->user_id = $request->user()->id;
        $data['user_id'] = $post->user_id;

        $post->create($data);

        return redirect()->route('users.index')->with('message', 'New post created!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $post = Post::findOrFail($id);
        $post->setRelation('comments', $post->comments()->latest()->paginate(4));
        return view('posts.show', compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Post $post
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function edit(Post $post)
    {
        $this->authorize('update', $post);
        return view('posts.edit', compact('post'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param Post $post
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Request $request, Post $post)
    {
        $request->validate([
            'description' => 'required|min:10'
        ]);
        $data = $request->all();
        $post->update($data);
        return redirect()->route('users.index')->with('message', 'Post updated!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\JsonResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function destroy($id)
    {
        $post = Post::findOrFail($id);
        $this->authorize('delete', $post);
        $post->comments()->delete();
        $post->delete();

        return response()->json([
            'status'=> 'ok'
        ], 204);
    }
}

resources/views/posts/create.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="col-6">
            <form method="post" action="{{route('posts.store')}}" enctype="multipart/form-data">
                @csrf
                <div class="form-group">
                    <label for="description"><b>Description</b></label>
                    <textarea name="description" class="form-control @error('description') is-invalid @enderror" id="description"></textarea>
                    @error('description')
                    <p class="error">{{ $message }}</p>
                    @enderror
                </div>
                <div class="form-group">
                    <div class="custom-file">
                        <input type="file" class="custom-file-input  @error('image') is-invalid @enderror" id="customFile" name="image">
                        <label class="custom-file-label" for="customFile">Upload photo</label>
                    </div>
                </div>
                @error('image')
                <p class="error">{{ $message }}</p>
                @enderror
                <button type="submit" class="btn btn-primary active pl-4 pr-4 mr-3">Create</button>
                <a href="{{route('users.index')}}">Back</a>
            </form>
        </div>
    </div>
@endsection

resources/views/posts/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container mt-2">
        <div class="col-6">
            <h5>Edit post:</h5>
            <form method="post" action="{{route('posts.update', ['post' => $post])}}" enctype="multipart/form-data">
                @csrf
                @method('put')
                <div class="form-row">
                    <div class="form-group col-md-10">
                        <textarea rows="5" class="form-control @error('description') is-invalid @enderror"
                                  id="description"
                                  name="description">{{$post->description}}</textarea>
                        @error('description')
                        <p class="error">{{$message}}</p>
                        @enderror
                    </div>
                </div>
                <button type="submit" class="btn btn-primary active pl-4 pr-4 mr-3">Edit</button>
                <a href="{{route('users.index')}}">Back</a>
            </form>
        </div>
    </div>
@endsection

resources/views/posts/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        @if (session('message'))
            <div class="alert alert-primary" role="alert">
                {{ session('message') }}
            </div>
        @endif
        <div class="row d-flex justify-content-center">
            @csrf
            @foreach($posts as $post)
                @foreach($users as $user)
                    @if($post->user->id == $user->id)
                        <div class="col-md-4 mt-4" id="delete-post-{{$post->id}}">
                            <div class="card ml-0 mr-0">
                                <div class="card-header d-flex justify-content-between">
                                    {{$post->user->name}}
                                </div>
                                <div class="card-body pb-1">
                                    <img class="img-fluid"
                                         src="{{asset('/storage/' . $post->image)}}" alt="Photo">
                                    <blockquote class="blockquote mb-0 pt-1">
                                        <p class="text-truncate mb-0" style="font-size: 15px;">
                                            {{ $post->description }}
                                        </p>

                                        <div class="d-flex justify-content-between pb-0">
                                            @if($post->likes->count() > 0)
                                                <a>
                                                    <i class="fa fa-heart" style="color: indianred"
                                                      aria-hidden="true"></i>
                                                    <span style="font-size: 12px"> {{$post->likes->count()}} </span>
                                                </a>
                                            @endif
                                        <a href="{{route('posts.show', ['post' =>$post])}}"
                                           class="card-link mt-2">More</a>
                                        </div>
                                        @can('update', $post)
                                            <a href="{{route('posts.edit', ['post' => $post])}}"
                                               class="card-link">Edit post</a>
                                        @endcan
                                    </blockquote>
                                </div>
                                <div class="card-footer">
                                    <div class="d-flex justify-content-between">
                                        <form method="post" action="{{route('posts.likes.store', ['post' => $post])}}">
                                            @csrf
                                            <input type="hidden" id="post_id" value="{{$post->id}}">
                                            <button type="submit" class="btn btn-outline-light active p-0">Like
                                            </button>
                                        </form>
                                        @if ($post->comments->count() == 1)
                                            <span> {{$post->comments->count()}} Comment</span>
                                        @elseif($post->comments->count() > 1 || $post->comments->count() == 0)
                                            <span> {{$post->comments->count()}} Comments</span>
                                        @endif
                                        @can('delete', $post)
                                            <input type="hidden" id="post-id" value="{{$post->id}}">
                                            <span data-post-id="{{$post->id}}" class="delete"
                                                  aria-hidden="true">&times;</span>
                                        @endcan
                                    </div>
                                </div>
                            </div>
                        </div>
                    @endif
                @endforeach
            @endforeach
        </div>
    </div>
@endsection

resources/views/posts/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        @if (session('message'))
            <div class="alert alert-primary" role="alert">
                {{ session('message') }}
            </div>
        @endif
        <div class="row">
            <div class="col-md-12">
                <h3>{{$post->user->name}}</h3>
                <img class="img-fluid"
                     src="{{asset('/storage/' . $post->image)}}" alt="Photo">
                <blockquote class="blockquote pt-3">
                    <p class="mb-2" style="text-align: justify; font-size: 15px;">
                        {{$post->description}}
                    </p>
                </blockquote>
            </div>
        </div>

        <div class="row mt-4">
            <div id="comments-block" class="col-7">
                @csrf
                @foreach($post->comments as $comment)
                    @if($comment->approved == 1)
                    <div class="media" id="delete-comment-{{$comment->id}}">
                        <img class="d-flex rounded-circle mt-0 mr-3" style="width: 50px; height: 50px"
                             src="{{asset('/images/default_photo.jpeg')}}" alt="Image">
                        <div class="media-body">
                            <div class="mb-3">
                                @can('delete', $comment)
                                    <input type="hidden" id="post-id" value="{{$post->id}}">
                                    <span data-comment-id="{{$comment->id}}" class="delete" aria-hidden="true"
                                          style="float: right; font-size: 20px;"
                                          value="{{$post->id}}">&times;</span>
                                @endcan
                            </div>
                            <p class="pr-4">{{$comment->body}}</p>
                            <div class="comment">
                                <span>Commented: {{$comment->user->name}}, </span>
                                <span>{{$comment->created_at->diffForHumans()}}</span>
                            </div>
                            @can('update', $comment)
                                <div>
                                    <a href="{{route('posts.comments.edit', ['post' => $post, 'comment' => $comment])}}"
                                       style="font-size: 12px">Edit</a>
                                </div>
                            @endcan
                            <hr>
                        </div>
                    </div>
                    @endif
                @endforeach
            </div>
            @if (Auth::user()->id !== $post->user->id)
                <div class="col-md-4 ml-auto mt-3">
                    <div class="comment-form">
                        <form id="add-comment">
                            @csrf
                            <input type="hidden" id="post_id" value="{{$post->id}}">
                            <div class="form-group">
                                <label for="body">Comment</label>
                                <textarea name="body" class="form-control" id="body" rows="3" required></textarea>
                            </div>
                            <button id="add-comment-btn" type="submit" class="btn btn-primary btn-block">Add comment
                            </button>
                        </form>
                    </div>
                </div>
            @endif
        </div>
        <div class="row p-5">
            <div class="col-10 offset-5">
                {{$post->comments->links()}}
            </div>
        </div>
    </div>
@endsection